=== src/plugins/CMakeLists.txt ===
########################################################################
# CMakeList.txt plugins
########################################################################


add_subdirectory( level )

add_subdirectory( charts )

add_subdirectory( settings )

add_subdirectory( wizard )

add_subdirectory( updater )
