=== debian/changelog ===
nootka (1.2.0-0ubuntu3) xenial; urgency=medium

  * No-change rebuild against libsoundtouch1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 10 Nov 2015 20:38:21 +0000

nootka (1.2.0-0ubuntu2) wily; urgency=medium

  * No-change rebuild against libjack-jackd2-0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 11 Aug 2015 06:59:25 +0000

nootka (1.2.0-0ubuntu1) wily; urgency=medium

  * New upstream release
  * debian/control:
    - Switch build-deps to Qt5
    - Run wrap-and-sort -sa
    - Bump standards-version to 3.9.6 (no changes)
    - Bump debhelper version to 9

 -- Jackson Doak <noskcaj@ubuntu.com>  Fri, 03 Jul 2015 14:35:27 +1000
