=== debian/control ===
Source: nootka
Section: sound
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Howard Chan <smartboyhw@gmail.com>
Build-Depends:
 cmake,
 debhelper (>= 9),
 libasound2-dev,
 libfftw3-dev,
 libjack-dev,
 libpulse-dev,
 libsoundtouch-dev,
 libvorbis-dev,
 pkg-kde-tools,
 qtbase5-dev
Standards-Version: 3.9.6
Homepage: http://nootka.sourceforge.net/

Package: nootka
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: This package nootka provides an application to learn classical score notation.
 Nootka is an application to learn classical score notation.
 It helps to understand the rules of reading and writing scores
 and develops skills for playing and singing notes.
