=== debian/watch ===
version=3
http://sf.net/nootka/nootka-(\d\S*)-source\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
